import java.net.ServerSocket;
import java.net.Socket;

public class ThreadedServer {

	ServerSocket ssocket;
	
	public ThreadedServer(int port) {
		try {
			ssocket = new ServerSocket(port);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void serve() {
		System.out.println("Server started, waiting for connection");
		try {
			while (true) {
				Socket sock = ssocket.accept();
				ServerThread t = new ServerThread(sock);
				t.start();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		ThreadedServer s = new ThreadedServer(Integer.parseInt(args[0]));
		s.serve();
	}

	class ServerThread extends Thread {
		Socket sock;

		public ServerThread(Socket s) {
            super();
            sock=s;
        }
        
        public void run() {
            ConnectionHandler.handleConnection(sock);
        }
	}
}
